#include <OSA.h>


#if   defined(__OSAPICC18__)
    #include <pic18.h>
#elif defined (__OSAPICC__)
    #include <pic.h>
#endif


//------------------------------------------------------------------------------
#ifdef __OSAMCC18__
#pragma udata access ACCESS
#endif



NEAR OST_SYSTEM_FLAGS   OS_Flags    __osa30_near;
NEAR _OST_INT_TYPE      _OS_temp    __osa30_near;
NEAR _OST_INT_TYPE      _OS_tempH   __osa30_near;


OST_TASK_POINTER NEAR _OS_CurTask   __osa30_near;    //  

OST_TASK_POINTER NEAR _OS_BestTask __osa30_near;   //     (   OS_Sched() )
OST_TASK_POINTER NEAR _OS_LastTask __osa30_near;   //   
NEAR _OST_INT_TYPE _OS_best_priority __osa30_near;


//------------------------------------------------------------------------------
#ifdef __OSAMCC30__
NEAR OST_TASK_STATE     OS_state    __osa30_near;
#endif

#ifdef OS_ENABLE_TIMER

    NEAR _OST_INT_TYPE  OS_Ticks    __osa30_near;

    #ifdef OS_ENABLE_PTIMERS
        NEAR OST_PTIMER_CB  _OS_PTimers __osa30_near;       //    
        #if defined(__OSAMCC30__)
            NEAR OST_PTIMER * _OS_PTimerWork __osa30_near; //    
        #endif
    #endif
#endif

#ifdef __OSAMCC18__
#pragma udata
#endif
//------------------------------------------------------------------------------


            

//------------------------------------------------------------------------------
#if OS_BSEMS > 0
            #if OS_BANK_BSEM == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_bsems
                #endif
            #endif
OS_BSEM_BANK _OST_INT_TYPE OS_BSems[(OS_BSEMS + _OST_INT_SIZE-1) / _OST_INT_SIZE] __osa30_near;
            #if OS_BANK_BSEM == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------




//------------------------------------------------------------------------------
//    
            #if OS_BANK_TASKS == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_tasks
                #endif
            #endif
OS_TASKS_BANK OST_TCB OS_TaskVars[OS_TASKS] __osa30_near;
            #if OS_BANK_TASKS == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
//------------------------------------------------------------------------------




//------------------------------------------------------------------------------
//    
#if OS_TIMERS > 0
            #if OS_BANK_TIMEOUTS == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_timeout
                #endif
            #endif
OS_TIMEOUTS_BANK _OST_INT_TYPE OS_Timeouts[(OS_TIMERS + _OST_INT_SIZE - 1) / _OST_INT_SIZE] __osa30_near;
            #if OS_BANK_TIMEOUTS == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------




//------------------------------------------------------------------------------
#if OS_TIMERS32 > 0
            #if OS_BANK_TIMERS32 == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_timers32
                #endif
            #endif
OS_TIMERS32_BANK __osa_uint32 OS_Timers32[OS_TIMERS32] __osa30_near;   //   
            #if OS_BANK_TIMERS32 == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------
#if OS_TIMERS24 > 0
            #if OS_BANK_TIMERS24 == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_timers24
                #endif
            #endif
OS_TIMERS24_BANK __osa_uint16 OS_Timers24[OS_TIMERS24] __osa30_near;   //   
            #if OS_BANK_TIMERS24 == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------
#if OS_TIMERS16 > 0
            #if OS_BANK_TIMERS16 == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_timers16
                #endif
            #endif
OS_TIMERS16_BANK __osa_uint16 OS_Timers16[OS_TIMERS16] __osa30_near;   //   
            #if OS_BANK_TIMERS16 == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------
#if OS_TIMERS8 > 0
            #if OS_BANK_TIMERS8 == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_timers8
                #endif
            #endif
OS_TIMERS8_BANK __osa_uint8 OS_Timers8[OS_TIMERS8] __osa30_near;   //   
            #if OS_BANK_TIMERS8 == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------




//------------------------------------------------------------------------------
//      , .. PICC   
// #locate,     #ifdef'
#ifdef __OSACCS18__
#include "osa_ccs18_locate.h"
#endif











/**************************************************************************************************
 * 
 *                                       M C C 3 0
 *
 *
 **************************************************************************************************/

#if defined(__OSA30__)

/************************************************************************/
/*                          */
/************************************************************************/

void _OS_SchedRetPoint (void)
{
    OS_state.bReady = 1;
    asm volatile("   ulnk                    ");
    asm volatile("   mov     __OS_CurTask, w0 ");
    asm volatile("   pop.d   w2              ");
    asm volatile("   mov     w2, [w0 + #2]   ");
    asm volatile("   mov     w3, [w0 + #4]   ");
}

/************************************************************************/
/*                        */
/************************************************************************/
void _OS_SchedRetPointNoSave (void)
{
    asm volatile("   ulnk                    ");
    asm volatile("   pop.d   w2              ");
}

/************************************************************************/
/*                                                                      */
/************************************************************************/


void _OS_CLEAR_READY (void)
{
    OS_Flags.bEventError = 0;
    OS_state.bReady = 0;
    #ifdef OS_ENABLE_TIMER
    OS_state.bCanContinue = 0;
    #endif
    asm volatile("   mov     __OS_CurTask, w0 ");
    asm volatile("   mov     [w15 - #4], w3  ");
    asm volatile("   mov     [w15 - #6], w2  ");
    asm volatile("   mov     w2, [w0 + #2]   ");
    asm volatile("   mov     w3, [w0 + #4]   ");
}

void _OS_CLEAR_READY_SET_CANCONTINUE (void)
{
    OS_Flags.bEventError = 0;
    OS_state.bReady = 0;
    #ifdef OS_ENABLE_TIMER
    OS_state.bCanContinue = 1;
    #endif
    asm volatile("   mov     __OS_CurTask, w0 ");
    asm volatile("   mov     [w15 - #4], w3  ");
    asm volatile("   mov     [w15 - #6], w2  ");
    asm volatile("   mov     w2, [w0 + #2]   ");
    asm volatile("   mov     w3, [w0 + #4]   ");
}


#endif  // __OSA30__














/**************************************************************************************************
 * 
 *                                       M C C 1 8 
 *
 *
 **************************************************************************************************/

#if defined(__OSA18__)

void _OS_ClrReadySetClrCanContinue (void);

/************************************************************************/
/*                          */
/************************************************************************/

void OS_SchedRetPoint (void)
{
    #ifdef __OSAMCC18__
        
        //_fsr = (_FSR_TYPE)&_OS_CurTask->cTempFSR1;
        _OS_SET_FSR_CUR_TASK_W(OS_CODE_POINTER_SIZE + 1);
        _postdec = _fsr1l - _OS_tempH;

    #else 

        //_fsr = ((_FSR_TYPE)&_OS_CurTask->cTempFSR1) - 1;
        _OS_SET_FSR_CUR_TASK_W(OS_CODE_POINTER_SIZE);

    #endif

    _OS_SavePC();
    _OS_SetIndfReady();
    
    _PIC18_POP();
}

/************************************************************************/
/*                        */
/************************************************************************/
void OS_SchedRetPointNoSave (void)
{
    _PIC18_POP();
}

/************************************************************************/
/*                                                                      */
/************************************************************************/


#if defined(__OSAPICC18__)
    asm("   global  _OS_ClearReady");
    asm("_OS_ClearReady:     ");
    asm("   clrf    __OS_temp, c    ");
    asm("   global  __OS_ClrReadySetClrCanContinue  ");
    asm("   goto    __OS_ClrReadySetClrCanContinue  ");
#else
    void OS_ClearReady (void)
    {
        _OS_temp = 0;

    #if defined(__OSACCS18__)
        _OS_ClrReadySetClrCanContinue();
    #endif
    #if defined(__OSAMCC18__)
        _asm    goto    _OS_ClrReadySetClrCanContinue   _endasm
    #endif
    }
#endif

/************************************************************************/
/*                                                                      */
/************************************************************************/
#if defined(__OSAPICC18__)
    asm("   global  _OS_ClearReadySetCanContinue");
    asm("_OS_ClearReadySetCanContinue:     ");
    asm("   setf    __OS_temp, c    ");
    asm("   global  __OS_ClrReadySetClrCanContinue  ");
    asm("   goto    __OS_ClrReadySetClrCanContinue  ");
#else
    void OS_ClearReadySetCanContinue (void)
    {
        _OS_temp = 0xFF;
    #if defined(__OSACCS18__)
        _OS_ClrReadySetClrCanContinue();
    #endif
    #if defined(__OSAMCC18__)
        _asm    goto    _OS_ClrReadySetClrCanContinue   _endasm
    #endif
    }
#endif


//------------------------------------------------------------------------------
//      
//    GOTO :
//      OS_ClearReady()
//      OS_ClearReadySetCanContinue()
// ,   -  ,  
//------------------------------------------------------------------------------
void _OS_ClrReadySetClrCanContinue (void)
{


    OS_Flags.bEventError = 0;
    //_fsr = (_FSR_TYPE)&_OS_CurTask->cTempFSR1;
    
    #ifdef __OSAMCC18__
        _OS_SET_FSR_CUR_TASK_W(OS_CODE_POINTER_SIZE + 1);
        _postdec = _fsr1l - _OS_tempH;
    #else
        _OS_SET_FSR_CUR_TASK_W(OS_CODE_POINTER_SIZE);
    #endif
    _OS_SavePC();

    _OS_ClearIndfReady();

    #if defined(OS_ENABLE_TIMER)
        _OS_ClearIndfCanContinue();
        if (_OS_temp & 0x01) _OS_SetIndfCanContinue();
    #endif

    #if defined(__OSACCS18__)
        _PIC18_POP();
    #endif
}



#endif // __OSA18__













/**************************************************************************************************
 * 
 *            F S R       O S _ C U R _ T A S K
 *
 *   
 *
 **************************************************************************************************/
#if     defined(__OSAPICC__)

    #if defined(_ROMSIZE) && (_ROMSIZE <= 0x800)

        asm("   global __OS_SET_FSR_CUR_TASK        ");
        asm("   global __OS_SET_FSR_CUR_TASK_W      ");
        asm("__OS_SET_FSR_CUR_TASK:                 ");
        asm("       movlw       0                   ");
        asm("__OS_SET_FSR_CUR_TASK_W:               ");
        asm("       addwf       __OS_CurTask, w     ");
        asm("       movwf       __fsr               ");
        #if OS_BANK_TASKS >= 2
        asm("       bsf         __status, 7         ");
        #else
        asm("       bcf         __status, 7         ");
        #endif
        asm("       return                          ");
    
    #endif

#elif defined(__OSAPICC18__)

    asm("   global __OS_SET_FSR_CUR_TASK        ");
    asm("   global __OS_SET_FSR_CUR_TASK_W      ");
    asm("__OS_SET_FSR_CUR_TASK:                 ");
    _PIC18_ERRATA_NOP();
    asm("       movlw       0                   ");
    asm("__OS_SET_FSR_CUR_TASK_W:               ");
    _PIC18_ERRATA_NOP();
    asm("       addwf       __OS_CurTask+0, w, c");
    asm("       movwf       __fsr + 0, c        ");
    #if OS_BANK_TASKS == 0
    asm("       clrf        __fsr + 1, c        ");
    #else 
    asm("       movlw       0                   ");
    asm("       addwfc      __OS_CurTask+1, w, c");
    asm("       movwf       __fsr + 1, c        ");
    #endif
    asm("       return                          ");

#elif defined(__OSAMCC18__)

    void _OS_SET_FSR_CUR_TASK (void)
    {
        _asm    
            movlw   0
            goto __OS_SET_FSR_CUR_TASK_W
        _endasm
    }

    void __OS_SET_FSR_CUR_TASK_W (void)
    {
        _asm
            addwf   _OS_CurTask + 0, 0, 0
            movwf   _fsr + 0, 0
            #if OS_BANK_TASKS == 0 
                clrf    _fsr + 1, 0
            #else
                movlw   0
                addwfc  _OS_CurTask + 1, 0, 0
                movwf   _fsr + 1, 0
            #endif
        _endasm
    }

#elif defined(__OSACCS18__)
#endif





















/**************************************************************************************************
 * 
 * C O U N T I N G    S E M A P H O R E S
 *
 * (OS_ENABLE_CSEM must be defined in OSAcfg.h)
 *
 **************************************************************************************************/


#ifdef OS_ENABLE_CSEM

#if OS_CSEM_SIZE > 1
/************************************************************************/
/*                                              */
/************************************************************************/

    bit _OS_CheckCSem(OST_CSEM *pCSem)
    {
        _OST_INT_TYPE cGIETemp;
        cGIETemp = OS_DI();
        if (*pCSem) cGIETemp |= 1;
        OS_RI(cGIETemp);
        if (cGIETemp & 1) return 1;
        return 0;
    }

/************************************************************************/
/*  ()                                  */
/************************************************************************/
    void _OS_ClearCSem(OST_CSEM *pCSem)
    {
        _OST_INT_TYPE cGIETemp;
        cGIETemp = OS_DI();
        *pCSem = 0;
        OS_RI(cGIETemp);
    }

#endif


/************************************************************************/
/*     1                                    */
/************************************************************************/
void _OS_SignalCSem (OST_CSEM *pCSem)
{
    #ifdef OS_ENABLE_INT_SERVICE
        _OST_INT_TYPE cGIETemp;
        cGIETemp = OS_DI();
    #endif

    OS_Flags.bEventError = 0;               //   ,    

    //------------------------------------------------------------------------------
    //    
    #if OS_CSEM_SIZE == 1
    
        #if defined(__OSAPICC__) || defined(__OSAPICC18__)
            _fsr = (_FSR_TYPE)pCSem;
            #ifdef __OSAPICC__
                _status &= 0x7F;        //  IRP
            #endif
            _indf++;
            if (!_indf)
            {
                _indf--;
                OS_Flags.bEventError = 1;
            }
        #else
            (*pCSem)++;
            if (!*pCSem) {
                (*pCSem) = 0xFF;
                OS_Flags.bEventError = 1;
            }
        #endif

    //------------------------------------------------------------------------------
    //    
    #elif OS_CSEM_SIZE == 2
        #if  defined(__OSAPICC__)
            _fsr = (_FSR_TYPE)pCSem;
            _status &= 0x7F;        //  IRP
            asm("\t    movlw    1     ");
            asm("\t    addwf    __indf,f    ");
            asm("\t    incf     __fsr, f    ");
            asm("\t    btfsc    __status, 0     ");
            asm("\t    incf     __indf,f     ");
            asm("\t    movf     __indf, w     ");
            asm("\t    decf     __fsr, f     ");
            asm("\t    iorwf    __indf, w      ");
            if (ZERO) {
                asm("\t    movlw    -1     ");
                asm("\t    movwf    __indf     ");
                asm("\t    incf     __fsr,f     ");
                asm("\t    movwf    __indf     ");
                OS_Flags.bEventError = 1;
            }
        #else
            (*pCSem)++;
            if (!*pCSem) {          //   ,    
                (*pCSem) = 0xFFFF;
                OS_Flags.bEventError = 1;
            }
        #endif
    //------------------------------------------------------------------------------
    //    
    #else 
        (*pCSem)++;
        if (!*pCSem) {          //   ,    
            (*pCSem) = 0xFFFFFFFF;
            OS_Flags.bEventError = 1;
        }
    #endif
    //------------------------------------------------------------------------------
    
    #ifdef OS_ENABLE_INT_SERVICE
        OS_RI(cGIETemp);
    #endif
}

#endif











/****************************************************************************************************
 * 
 *       GIEH:GIEL
 * 
 * char OS_DI (void)   
 *
 ****************************************************************************************************/
/****************************************************************************************************
 * 
 *       OS_DI 
 * 
 * void OS_RI (char)   
 *
 ****************************************************************************************************/
#if defined(__OSAMCC30__) 

    _OST_INT_TYPE OS_DI (void)
    {
        _OST_INT_TYPE temp;
        temp = SR;
        SR |= 0x00E0;
        return temp & 0x00E0;
    }

    void OS_RI (_OST_INT_TYPE temp)
    {
        temp |= 0xFF1F;
        SR |= 0x00E0;
        SR &= temp;
    }


#elif defined(__OSAPICC18__)


    asm("   global _OS_DI           ");
    asm("_OS_DI:                    ");
    asm("   dw      0xFFFF          ");
    asm("   movf    __intcon, w, c   ");
    asm("   andlw   0xC0            ");
    asm("_DIH_REPEAT:               ");
    asm("   bcf     __intcon, 7, c   ");
    asm("   btfsc   __intcon, 7, c   ");
    asm("   bra     _DIH_REPEAT     ");
    
    asm("   btfss   __rcon, 7, c     ");
    asm("   bra     _DI_EXIT        ");
    asm("_DIL_REPEAT:               ");
    asm("   bcf     __intcon, 6, c   ");
    asm("   btfsc   __intcon, 6, c   ");
    asm("   bra     _DIL_REPEAT     ");
    asm("_DI_EXIT:                  ");
    asm("   return                  ");
    asm("   dw      0xFFFF          ");


    asm("   global  _OS_RI          ");
    asm("_OS_RI:                    ");
    asm("   dw      0xFFFF          ");
    asm("   btfsc   _WREG, 7, c     ");
    asm("   bsf     __intcon, 7, c   ");
    asm("   btfsc   __rcon, 7, c     ");
    asm("   btfss   __wreg, 6, c     ");
    asm("   bra     _RI_EXIT        ");
    asm("   bsf     __intcon, 6, c   ");
    asm("_RI_EXIT:                  ");
    asm("   return                  ");
    asm("   dw      0xFFFF          ");



#elif defined(__OSAPICC__)
/****************************************************************************************************
 * 
 *       GIE
 * 
 * char OS_DI (void)   
 *
 ****************************************************************************************************/

    asm("   global _OS_DI           ");
    asm("_OS_DI:                    ");
    asm("   clrf    __status        ");
    asm("   movf    __intcon, w      ");
    asm("   andlw   0x80            ");
    asm("_DI_REPEAT:                ");
    asm("   bcf     __intcon, 7      ");
    asm("   btfss   __intcon, 7      ");
    asm("   return                  ");
    asm("   goto    _DI_REPEAT      ");



#elif defined(__OSAMCC18__)
    char OS_DI (void)
    {
        _asm
            movf    _intcon, 0, 0
            andlw   0xC0
        _DIH_REPEAT:
            bcf     _intcon, 7, 0
            btfsc   _intcon, 7, 0
            bra     _DIH_REPEAT
            btfss   _rcon, 7, 0
            bra     _DI_EXIT
        _DIL_REPEAT:
            bcf     _intcon, 6, 0
            btfsc   _intcon, 6, 0
            bra     _DIL_REPEAT
        _DI_EXIT:
        _endasm
    }


    void _OS_RI ()
    {
        _asm
            btfsc   _wreg, 7, 0
            bsf     _intcon, 7, 0
            btfsc   _rcon, 7, 0
            btfss   _wreg, 6, 0
            bra     _RI_EXIT
            bsf     _intcon, 6, 0
        _RI_EXIT:
        _endasm

    }


#else       //    


    char OS_DI (void)
    {
        char temp;
        temp = _intcon & 0xC0;
        do {
            _intcon &= 0x7F;
        } while (_intcon & 0x80);
        if (_rcon & 0x80)
        {
            do {
                _intcon &= 0xBF;
            } while (_intcon & 0x40);
        }
        return temp;
    }


    void OS_RI (char temp)
    {
        if (temp & 0x80) _intcon |= 0x80;
        if (_rcon & 0x80)
            if (temp & 0x40) _intcon |= 0x40;
    }

#endif  // __OSACCS18__









 
    
    
/****************************************************************************************************
 * 
 *        
 * 
 *
 ****************************************************************************************************/
//------------------------------------------------------------------------------
#ifdef OS_ENABLE_CRITICAL_SECTION
//------------------------------------------------------------------------------
    
/************************************************************************/
/*                                                */
/************************************************************************/
void OS_EnterCriticalSection (void)
{
    _OST_INT_TYPE temp;
    temp = OS_DI();
    OS_Flags.bInCriticalSection = 1; 

    #ifdef __OSAMCC30__
        OS_Flags.cIPL_Temp = 0;
        *((unsigned int *)&OS_Flags) |= temp;
    #else
        OS_Flags.bGIE_CTemp = 0;
        if (temp & 0x80) OS_Flags.bGIE_CTemp = 1;

        #if defined(__OSA18__)
            OS_Flags.bGIEL_CTemp = 0;
            if (temp & 0x40) OS_Flags.bGIEL_CTemp = 1;
        #endif
    #endif
}

/************************************************************************/
/*                                              */
/************************************************************************/
void OS_LeaveCriticalSection (void)
{
    char temp;
    OS_Flags.bInCriticalSection = 0; 
    #ifdef __OSAMCC30__
        temp = *((unsigned int *)&OS_Flags) & 0x00E0;
    #else
        temp = 0;
        if (OS_Flags.bGIE_CTemp) temp |= 0x80;
        #if defined(__OSA18__)
            if (OS_Flags.bGIEL_CTemp) temp |= 0x40;
        #endif
    #endif
    OS_RI(temp);
}

//------------------------------------------------------------------------------
#endif      //     #ifdef OS_ENABLE_CRITICAL_SECTION
//------------------------------------------------------------------------------


















//------------------------------------------------------------------------------
#ifdef OS_ENABLE_TIMER

/****************************************************************************************************
 * 
 *                                  
 *  
 *     ( OSAcfg.h  OS_SLOW_TIMERS      )
 *
 ****************************************************************************************************/
/************************************************************************/
/*                                                                      */
/*                                    */
/* (  )                                         */
/*                                                                      */
/************************************************************************/
    void _OS_InitDelay (OST_TIMER Delay)
    {

        #if defined(__OSAMCC18__)
            char temp;
            temp = 0;               //    MCC18:     Delay
            if (Delay) temp = 1;    //   FSR0 (.  (temp & 1))
        #endif
        
        #ifndef __OSAMCC30__
            _OS_SET_FSR_CUR_TASK();
        #endif
        _OS_ClearIndfCanContinue();
        _OS_ClearIndfDelay();

        #if defined(__OSAMCC30__)
            _OS_CurTask->State = OS_state;  //   bDelay,    
        #endif
        
      #if defined(__OSAMCC18__)
        if (temp & 1)           
      #else
        if (Delay)
      #endif
        {

            #if defined(__OSAMCC30__)
                Delay = -Delay;
            #else
                #if   OS_TIMER_SIZE == 1
                    Delay ^= 0xFF;
                #endif
                #if   OS_TIMER_SIZE == 2
                    Delay ^= 0xFFFF;
                #endif
                #if   OS_TIMER_SIZE == 4
                    Delay ^= 0xFFFFFFFF;
                #endif
                Delay ++;
            #endif
            _OS_CurTask->Timer = Delay;
            
            _OS_SET_FSR_CUR_TASK();
            _OS_SetIndfDelay();
            _OS_SetIndfReady();

        }
        #if defined(__OSAMCC30__)
            _OS_CurTask->State = OS_state;  //   Ready  Delay
        #endif
    }

//______________________________________________________________________________
//******************************************************************************

#endif  // #ifdef OS_TIMER



    










    
    
    
    
    

    








/****************************************************************************************************
 * 
 * 
 *                                   
 *  
 *
 ****************************************************************************************************/

void OS_Init (void)
{

    #if (OS_BSEMS > 11*8) || (OS_TIMERS > 11*8) || ((OS_BSEMS > 0 || OS_TIMERS > 0) && defined(__OSAMCC30__))
        _OST_INT_TYPE n;
    #endif
    
    _OS_LastTask = (OS_TASKS_BANK OST_TASK_POINTER) &OS_TaskVars[OS_TASKS - 1];
    
    //------------------------------------------------------------------------------
    //   
    #if OS_TIMERS > 11*8 || ((OS_TIMERS > 0) && defined(__OSAMCC30__))
        n = sizeof(OS_Timeouts);
        do {
            OS_Timeouts[n-1] = 0;
        } while (--n);
    #else
        #if OS_TIMERS > 0
            OS_Timeouts[0] = 0;
        #endif

        #if OS_TIMERS > 1*8
            OS_Timeouts[1] = 0;
        #endif

        #if OS_TIMERS > 2*8
            OS_Timeouts[2] = 0;
        #endif

        #if OS_TIMERS > 3*8
            OS_Timeouts[3] = 0;
        #endif

        #if OS_TIMERS > 4*8
            OS_Timeouts[4] = 0;
        #endif

        #if OS_TIMERS > 5*8
            OS_Timeouts[5] = 0;
        #endif

        #if OS_TIMERS > 6*8
            OS_Timeouts[6] = 0;
        #endif

        #if OS_TIMERS > 7*8
            OS_Timeouts[7] = 0;
        #endif

        #if OS_TIMERS > 8*8
            OS_Timeouts[8] = 0;
        #endif

        #if OS_TIMERS > 9*8
            OS_Timeouts[9] = 0;
        #endif

        #if OS_TIMERS > 10*8
            OS_Timeouts[10] = 0;
        #endif

    #endif
    
    #if defined(OS_ENABLE_TIMER) && defined(OS_ENABLE_PTIMERS)
        *((char*)&_OS_PTimers.Flags) = 0;
        _OS_PTimers.Flags.bActive = 1;    //    OS_CreatePTimer
    #endif

    //------------------------------------------------------------------------------
    //   
    #if OS_BSEMS > 11*8 || ((OS_BSEMS > 0) && defined(__OSAMCC30__))
        n = sizeof(OS_BSems) / sizeof(_OST_INT_TYPE);
        do {
            OS_BSems[n-1] = 0;
        } while (--n);
    #else
        #if OS_BSEMS > 0
            OS_BSems[0] = 0;
        #endif

        #if OS_BSEMS > 1*8
            OS_BSems[1] = 0;
        #endif

        #if OS_BSEMS > 2*8
            OS_BSems[2] = 0;
        #endif

        #if OS_BSEMS > 3*8
            OS_BSems[3] = 0;
        #endif

        #if OS_BSEMS > 4*8
            OS_BSems[4] = 0;
        #endif

        #if OS_BSEMS > 5*8
            OS_BSems[5] = 0;
        #endif

        #if OS_BSEMS > 6*8
            OS_BSems[6] = 0;
        #endif

        #if OS_BSEMS > 7*8
            OS_BSems[7] = 0;
        #endif

        #if OS_BSEMS > 8*8
            OS_BSems[8] = 0;
        #endif

        #if OS_BSEMS > 9*8
            OS_BSems[9] = 0;
        #endif

        #if OS_BSEMS > 10*8
            OS_BSems[10] = 0;
        #endif
    #endif

   
    //------------------------------------------------------------------------------
    #if OS_TASKS > 0
        _OS_CurTask = (OST_TASK_POINTER) OS_TaskVars;
        _OS_temp = OS_TASKS;
        do {
            _OS_StopTask();
            _OS_CurTask ++;
        } while (--_OS_temp);
    #endif
    *((NEAR _OST_INT_TYPE*)&OS_Flags) = 0;
}   













    
    
    
    
    
/****************************************************************************************************
 * 
 * 
 *                                      
 *  
 *
 ****************************************************************************************************/
    
/************************************************************************/
/*                                                                      */
/*                     */
/*                                   */
/*                                                                      */
/************************************************************************/

 
void _OS_StopTask (void)
{
    #ifdef __OSAMCC30__
    *((OS_TASKS_BANK _OST_INT_TYPE*)&_OS_CurTask->State) = 0;
    #else
    _OS_SET_FSR_CUR_TASK();
    _indf = 0;
    #endif
}




/************************************************************************/
/*                                                                      */
/*     .                              */
/*  :                                                           */
/*      FSR -                                      */
/*      CARRY - =1 - ,                                                */
/*              =0 -    (  OS_TASKS)    */
/*                                                                      */
/************************************************************************/

//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------

bit _OS_CreateTask(_OST_INT_TYPE priority, OST_CODE_POINTER TaskAddr)
{
    OST_TASK_POINTER Task;

    #if defined(__OSAMCC30__)
        OST_TASK_POINTER Temp;
    #endif

    OS_Flags.bError = 0;

    #if defined(OS_DISABLE_PRIORITY)
    priority = 0;   //    
    #endif

    Task = (OST_TASK_POINTER)OS_TaskVars;
    _OS_temp = OS_TASKS;
    do {
        if (!Task->State.bEnable)
        {
            ((OST_TASK_STATE*)&priority)->bEnable = 1;
            ((OST_TASK_STATE*)&priority)->bReady = 1;
            

            #ifdef __OSAMCC30__
                Task->pTaskPointer = TaskAddr;
                Temp = _OS_CurTask;
                _OS_CurTask = Task;
                asm volatile("   mov     __OS_CurTask, w0    ");
                asm volatile("   mov     [w0 + #2], w2       ");
                asm volatile("   mov     [w0 + #4], w1       ");
                asm volatile("   mov     w1, TBLPAG          ");
                asm volatile("   tblrdl  [w2], w1            ");
                asm volatile("   inc2    w2, w2              ");
                asm volatile("   mov     w2, [w0 + #2]       ");
                asm volatile("   mov     w1, [w0+#6]         ");
                Task->State = *((OST_TASK_STATE*)&priority);
                if (Temp == Task) OS_state = Task->State;
                _OS_CurTask = Temp;
                
            #else            
                Task->pTaskPointer = TaskAddr;
                #ifdef OS_ENABLE_TIMER
                    Task->Timer = 0;
                #endif
                #ifdef __OSA18__
                    Task->cTempFSR1 = 0;
                #endif
                *((OS_TASKS_BANK char*)&Task->State) = priority;
                //    FSR =    
                #ifdef __OSAPICC18__
                _fsr = (OST_TASK_POINTER)Task;
                #endif
            #endif
            OS_Flags.bError = 0;
            return 1;
        
        }
        Task ++;
    } while (_OS_temp--);
    //  ,     
    OS_Flags.bError = 1;
    return 0;
}






























/****************************************************************************************************
 * 
 * 
 *                              
 *  
 *       
 *
 ****************************************************************************************************/


#ifdef OS_ENABLE_TIMER
#ifndef OS_USE_INLINE_TIMER
void OS_Timer (void)
{                            
    __OS_TimerInline(0);
}
#endif
#endif






 /******************************************************************************************
 *
 *             P T I M E R '    
 *
 ******************************************************************************************/
#ifdef OS_ENABLE_PTIMERS

/************************************************************************/
/*                                                                      */
/************************************************************************/
void _OS_CreatePTimer (OST_PTIMER *ptimer)
{
    _OS_temp = OS_DI();

    //------------------------------------------------------------------------------
    #if defined(__OSAPICC__)
    //------------------------------------------------------------------------------
        _fsr = (_FSR_TYPE) ptimer;
        _indf = *((char*)&_OS_PTimers.Flags); //  bActive,
                                              //  bTimeout,
                                              //  bRun
                                              //  bNextEnable;
        _fsr++;
        _indf = (_FSR_TYPE)_OS_PTimers.Next;

        _fsr++;
        _indf = 0;
        _fsr++;
        #if  OS_TIMER_SIZE >= 2
        _indf = 0;
        _fsr++;
        #endif
        #if  OS_TIMER_SIZE == 4
        _indf = 0;
        _fsr++;
        _indf = 0;
        #endif

    //------------------------------------------------------------------------------
    #elif defined(__OSAPICC18__) || defined(__OSAMCC18__) || defined(__OSACCS18__)
    //------------------------------------------------------------------------------
        _fsr = (_FSR_TYPE) ptimer;
        _postinc = *((NEAR char*)&_OS_PTimers.Flags);   //  bActive,
                                                        //  bTimeout,
                                                        //  bRun
                                                        //  bNextEnable
        _postinc = *((NEAR char*)&_OS_PTimers.Next + 0);
        _postinc = *((NEAR char*)&_OS_PTimers.Next + 1);
        _postinc = 0;
        #if  OS_TIMER_SIZE >= 2
        _postinc = 0;
        #endif
        #if  OS_TIMER_SIZE == 4
        _postinc = 0;
        _postinc = 0;
        #endif
    //------------------------------------------------------------------------------
    #else 
    //------------------------------------------------------------------------------
        // for __OSAMCC30__ and other
        ptimer->Next = _OS_PTimers.Next;
        ptimer->Flags = _OS_PTimers.Flags;
        ptimer->Timer = 0;
    //------------------------------------------------------------------------------
    #endif
    //------------------------------------------------------------------------------
        


    _OS_PTimers.Next = (OST_PTIMER*)ptimer;
    _OS_PTimers.Flags.bNextEnable = 1;
    OS_RI(_OS_temp);
}





/************************************************************************/
/*                                                                      */
/************************************************************************/
void _OS_DeletePTimer (OST_PTIMER *ptimer)
{

#if !defined(__OSAMCC30__)
    OST_PTIMER *ptcb;
#endif
    
    //------------------------------------------------------------------------------
    #if defined(__OSAPICC__)
    //______________________________________________________________________________
        char flags;
        _fsr = ((_FSR_TYPE)ptimer);
        flags = _indf;
        _OS_ClearIndfTimerActive;           //   
        _fsr++;
        ptcb = (_FSR_TYPE)_indf;
        _fsr = (_FSR_TYPE)&_OS_PTimers;
        //     
    REPEAT:
        if (_OS_CheckIndfTimerNextEnable)   // ,   
        {
            _fsr++;
            if ((_FSR_TYPE)_indf == (_FSR_TYPE)ptimer)  // ,    
            {
                _OS_temp = OS_DI();         //  
                _indf = *((char*)&ptcb);    //  
                _fsr--;                     
                //  ,      
                if (!((OST_PTIMER_FLAGS*)&flags)->bNextEnable) _OS_ClearIndfTimerNextEnable;
                OS_RI(_OS_temp);
                return;
            }
            _fsr = (_FSR_TYPE)_indf;
            goto REPEAT;
        }
    //------------------------------------------------------------------------------
    #elif defined(__OSAPICC18__)
    //______________________________________________________________________________
        char flags;
        _fsr = (_FSR_TYPE)ptimer;
        _OS_ClearIndfTimerActive;           //   
        flags = _postinc;
        *((char*)&ptcb + 0) = _postinc;
        *((char*)&ptcb + 1) = _postinc;
        _fsr = (_FSR_TYPE)&_OS_PTimers;
    REPEAT:
        if (_OS_CheckPostincTimerNextEnable)
        {
            if (_indf == *((char*)&ptimer + 0))
            {
                if (_preinc == *((char*)&ptimer + 1)){
                    _OS_temp = OS_DI();
                    _postdec = *((char*)&ptcb + 1);
                    _postdec = *((char*)&ptcb + 0);
                    if (!((OST_PTIMER_FLAGS*)&flags)->bNextEnable) _OS_ClearIndfTimerNextEnable;
                    return;
                }
                _fsr--;
            } 
            asm("   movf    __postinc, w, c     ");
            asm("   movff   __indf, __fsr + 1     ");
            asm("   movwf   __fsr + 0, c      ");
            goto REPEAT;
        }
    //------------------------------------------------------------------------------
    #elif defined(__OSAMCC18__)
    //______________________________________________________________________________
        char flags;
        _fsr = (_FSR_TYPE)ptimer;
        _OS_ClearIndfTimerActive;           //   
        flags = _postinc;
        *((char*)&ptcb + 0) = _postinc;
        *((char*)&ptcb + 1) = _postinc;
        _fsr = (_FSR_TYPE)&_OS_PTimers;
    REPEAT:
        if (_OS_CheckPostincTimerNextEnable)
        {
            if (_indf == *((char*)&ptimer + 0))
            {
                if (_preinc == *((char*)&ptimer + 1)){
                    _OS_temp = OS_DI();
                    _postdec = *((char*)&ptcb + 1);
                    _postdec = *((char*)&ptcb + 0);
                    if (!((OST_PTIMER_FLAGS*)&flags)->bNextEnable) _OS_ClearIndfTimerNextEnable;
                    return;
                }
                _fsr--;
            } 
            _asm
                movf    _postinc, 0, 0
                movff   _indf, _fsr + 1
                movwf   _fsr + 0, 0
            _endasm
        }
    //------------------------------------------------------------------------------
    #elif defined(__OSACCS18__)
    //______________________________________________________________________________
        char flags;
        _fsr = (_FSR_TYPE)ptimer;
        _OS_ClearIndfTimerActive;           //   
        flags = _postinc;
        *((char*)&ptcb + 0) = _postinc;
        *((char*)&ptcb + 1) = _postinc;
        _fsr = (_FSR_TYPE)&_OS_PTimers;
    REPEAT:
        if (_OS_CheckPostincTimerNextEnable)
        {
            if (_indf == *((char*)&ptimer + 0))
            {
                if (_preinc == *((char*)&ptimer + 1)){
                    _OS_temp = OS_DI();
                    _postdec = *((char*)&ptcb + 1);
                    _postdec = *((char*)&ptcb + 0);
                    if (!((OST_PTIMER_FLAGS*)&flags)->bNextEnable) _OS_ClearIndfTimerNextEnable;
                    return;
                }
                _fsr--;
            } 
            #asm
                movf    _postinc, 0, 0
                movff   _indf, _fsr + 1
                movwf   _fsr + 0, 0
            #endasm
        }
    //------------------------------------------------------------------------------
    #elif defined(__OSAMCC30__)
    //------------------------------------------------------------------------------
        asm volatile("   mov     #__OS_PTimers, w1       ");
        asm volatile("_OS_DELETE_PTIMER_NEXT:            ");
        asm volatile("   mov     w1, w5                  ");
        asm volatile("   mov     [w5], w2                ");
        asm volatile("   btss    w2, #3                  ");  // bNextEnable
        asm volatile("   goto    _OS_DELETE_PTIMER_EXIT  ");
        asm volatile("   mov     [w5 + #2], w1           ");
        asm volatile("   cpseq   w0, w1                  ");
        asm volatile("   goto    _OS_DELETE_PTIMER_NEXT  ");
        asm volatile("   mov.d   [w0], w2                "); // w2 = flags, w3 = next
        asm volatile("   mov     w3, [w5 + #2]           "); // w1.next = w0.next
        asm volatile("   mov     [w5], w3                "); // flags
        asm volatile("   btss    w2, #3                  "); // skip if bNextEnable
        asm volatile("   bclr    w3, #3                  "); // clear bNextEnable
        asm volatile("   mov     w3, [w5]                ");
        asm volatile("   bclr    w2, #1                  "); // clear bActive
        asm volatile("   mov     w2, [w0]                "); // save flags
        asm volatile("_OS_DELETE_PTIMER_EXIT:            ");
    //------------------------------------------------------------------------------
    #else
    //------------------------------------------------------------------------------
        // for all other
        ptcb = (OST_PTIMER*)&_OS_PTimers;
        while (ptcb->Flags.bNextEnable) {
            if (ptcb->Next == ptimer) {   //  
                ptcb->Next = ptimer->Next;
                if (!ptimer->Flags.bNextEnable) ptcb->Flags.bNextEnable = 0;
                ptimer->Flags.bActive = 0;
                return;
            }
            ptcb = ptcb->Next;
        }
        
        
    //------------------------------------------------------------------------------
    #endif
    //______________________________________________________________________________
        
}



#endif  //  OS_ENABLE_PTIMERS


























/****************************************************************************************************
 * 
 *                                /               
 *                  
 *
 * (  )
 *
 ****************************************************************************************************/


//------------------------------------------------------------------------------
#if     defined(__OSA16__)
    bit _OS_CheckEvent (char bEvent)
#elif   defined(__OSAMCC18__)
    #define bEvent  _OS_temp
    void _OS_CheckEvent (void)
#else   //  MCC30   C18
    void _OS_CheckEvent (_OST_INT_TYPE bEvent)
#endif
    {

/*      (      ) *
        OS_Flags.bTimeout = 0;
        _fsr = (_FSR_TYPE)&_OS_CurTask->State;
        _SET_TASK_IRP();
        if (bEvent) {
            if (_OS_CheckIndfReady()) {
                #ifdef OS_ENABLE_TIMER
                    _OS_ClearIndfDelay();
                #endif
                return 1;
            }
            _OS_SetIndfReady();
        } else {
            _OS_ClearIndfReady();
        }
        #ifdef OS_ENABLE_TIMER
            if (_OS_CheckIndfTimeout() && _OS_CheckIndfCanContinue()) {
                OS_Flags.bTimeout = 1;
                return 1;
            }
        #endif
        return 0;
*/


    
    
    #if     defined(__OSAMCC30__)

        OS_Flags.bTimeout = 0;
        asm volatile("  cp0     w0                          "); //  if (bEvent)
        asm volatile("  bra     Z, _OS_CHECK_EVENT_notEVENT ");
        asm volatile("  btss    _OS_state, #3               "); // Check ready
        asm volatile("  bra     _OS_CHECK_EVENT_SetReady    ");
        asm volatile("  bclr    _OS_state, #4               "); // Clear Delay
        asm volatile("  bra     _OS_CHECK_EVENT_EXIT_GOOD   ");
        asm volatile("_OS_CHECK_EVENT_SetReady:             ");
        asm volatile("  bset    _OS_state, #3               "); // Ready = 1
        asm volatile("  bra     _OS_CHECK_EVENT_CHECK_END   ");
        asm volatile("_OS_CHECK_EVENT_notEVENT:             ");
        asm volatile("  bclr    _OS_state, #3               "); // Ready = 1
        asm volatile("_OS_CHECK_EVENT_CHECK_END:            ");
        #ifdef OS_ENABLE_TIMER
            asm volatile("  btss    _OS_state, #4               "); //   
            asm volatile("  btss    _OS_state, #5               "); //   
            asm volatile("  bra     _OS_CHECK_EVENT_EXIT_BAD    ");
            OS_Flags.bTimeout = 1;
            asm volatile("  bra     _OS_CHECK_EVENT_EXIT_GOOD   ");
        #endif
        asm volatile("_OS_CHECK_EVENT_EXIT_BAD:             ");
        asm volatile("  ulnk                                "); //  CheckEvent
        asm volatile("  pop.d   w0                          "); //    
        asm volatile("_OS_CHECK_EVENT_EXIT_GOOD:            ");
/**/
    #elif defined(__OSAPICC__)
    
        OS_Flags.bTimeout = 0;
        _OS_SET_FSR_CUR_TASK();
        CARRY = 0;
        if (bEvent) {
            if (_OS_CheckIndfReady()) {
        EXIT_OK:
                CARRY = 1;
            }
            _OS_SetIndfReady();
            #if defined(OS_ENABLE_TIMER)
                if (CARRY) _OS_ClearIndfDelay();
            #endif
            asm("   return     ");
        }
        _OS_ClearIndfReady();
        #if defined(OS_ENABLE_TIMER)
            asm("   btfss   __indf, 4     ");
            asm("   btfss   __indf, 5     ");
            asm("   return                ");
            OS_Flags.bTimeout = 1;
            goto EXIT_OK;
        #else
            asm("   return  ");
        #endif
/**/
    #else
        OS_Flags.bTimeout = 0;
        _OS_SET_FSR_CUR_TASK(); //_fsr = (_FSR_TYPE)&_OS_CurTask->State;
                                // _SET_TASK_IRP();
        if (bEvent) {
            if (_OS_CheckIndfReady()) {
                #ifdef OS_ENABLE_TIMER
                    _OS_ClearIndfDelay();
                #endif
                return;
            }
            _OS_SetIndfReady();
        } else {
            _OS_ClearIndfReady();
        }
        #ifdef OS_ENABLE_TIMER
            if (_OS_CheckIndfTimeout() && _OS_CheckIndfCanContinue()) {
                OS_Flags.bTimeout = 1;
                return;
            }
        #endif
        _PIC18_POP();
        
    #endif  
    
    }


    

        

        






/****************************************************************************************************
 * 
 * 
 *                                                    
 *  
 *
 ****************************************************************************************************/


/************************************************************************/
/*                                                                      */
/*                           */
/*  1,                        */
/*                                                                      */
/************************************************************************/

#ifdef OS_ENABLE_QSMSG
void _OS_SendQSMsg (OST_QSMSG *pQSMsg, OST_SMSG SMsg)
{
    OST_QUEUE_CONTROL   q;
    _OST_INT_TYPE temp;

    #ifdef OS_ENABLE_INT_SERVICE
        _OST_INT_TYPE cGIETemp;
        cGIETemp = OS_DI();
    #endif
    
    q = pQSMsg->Q;
    OS_Flags.bEventError = 0;
    
    if (q.cSize == q.cFilled)                               //   ,    .
    {                                                       //   OS_SendQSMsg    
        pQSMsg->pSMsg[q.cBegin] = SMsg;                     // ,        .
        q.cBegin++;                                         //       OS_SendQSMsgNoWait,
        if (q.cBegin == q.cSize) q.cBegin = 0;              //       ,  
                                                            //   .
        OS_Flags.bEventError = 1;
        goto EXIT;
    }
    temp = q.cBegin + q.cFilled;
    if (temp >= q.cSize) temp -= q.cSize;
    pQSMsg->pSMsg[temp] = SMsg;
    q.cFilled++;
EXIT:
    pQSMsg->Q = q;
    #ifdef OS_ENABLE_INT_SERVICE
        OS_RI(cGIETemp);
    #endif
}
#endif


/************************************************************************/
/*                                                                      */
/*                                 */
/*                                                                      */
/************************************************************************/

#ifdef OS_ENABLE_QSMSG
OST_SMSG _OS_GetQSMsg (OST_QSMSG *pQSMsg)
{
    OST_QUEUE_CONTROL   q;
    _OST_INT_TYPE temp;
    #ifdef OS_ENABLE_INT_SERVICE
        _OST_INT_TYPE cGIETemp;
        cGIETemp = OS_DI();
    #endif

    q = pQSMsg->Q;
    temp = q.cBegin;
    q.cBegin++;
    if (q.cBegin >= q.cSize) q.cBegin = 0;
    q.cFilled--;
    pQSMsg->Q = q;
    #ifdef OS_ENABLE_INT_SERVICE
        OS_RI(cGIETemp);
    #endif
    return pQSMsg->pSMsg[temp];
}
#endif




/************************************************************************/
/*                                                                      */
/*                                   */
/*  1,                        */
/*                                                                      */
/************************************************************************/

#ifdef OS_ENABLE_QMSG

void _OS_SendQMsg (OST_QMSG *pQMsg, OST_MSG Msg)
{
    OST_QUEUE_CONTROL   q;
    _OST_INT_TYPE temp;

    #ifdef OS_ENABLE_INT_SERVICE
        _OST_INT_TYPE cGIETemp;
        cGIETemp = OS_DI();
    #endif
    q = pQMsg->Q;
    OS_Flags.bEventError = 0;
    
    if (q.cSize == q.cFilled)                               //   ,    .
    {                                                       //   OS_SendQSMsg    
        pQMsg->pMsg[q.cBegin] = Msg;                        // ,        .
        q.cBegin++;                                         //       OS_SendQSMsgNoWait,
        if (q.cBegin == q.cSize) q.cBegin = 0;              //       ,  
                                                            //   .
        OS_Flags.bEventError = 1;
        goto EXIT;
    }
    temp = q.cBegin + q.cFilled;
    if (temp >= q.cSize) temp -= q.cSize;
    pQMsg->pMsg[temp] = Msg;
    q.cFilled++;
EXIT:
    pQMsg->Q = q;
    #ifdef OS_ENABLE_INT_SERVICE
        OS_RI(cGIETemp);
    #endif
}


#endif


/************************************************************************/
/*                                                                      */
/*                                         */
/*                                                                      */
/************************************************************************/

#ifdef OS_ENABLE_QMSG
OST_MSG _OS_GetQMsg (OST_QMSG *pQMsg)
{
    OST_QUEUE_CONTROL   q;
    _OST_INT_TYPE temp;
    #ifdef OS_ENABLE_INT_SERVICE
        _OST_INT_TYPE cGIETemp;
        cGIETemp = OS_DI();
    #endif

    q = pQMsg->Q;
    temp = q.cBegin;
    q.cBegin++;
    if (q.cBegin >= q.cSize) q.cBegin = 0;
    q.cFilled--;
    pQMsg->Q = q;
    #ifdef OS_ENABLE_INT_SERVICE
        OS_RI(cGIETemp);
    #endif
    return pQMsg->pMsg[temp];
}
#endif




